<?php

namespace Drupal\cards\Plugin\Field\FieldWidget;


use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\entityreference_view_mode\Plugin\Field\FieldWidget\EntityReferenceViewModeWidget;

/**
 * Plugin implementation of the 'field_example_text' widget.
 *
 * @FieldWidget(
 *   id = "card_view_widget",
 *   module = "cards",
 *   label = @Translation("Card Widget"),
 *   field_types = {
 *     "card_view"
 *   }
 * )
 */
class CardWidget extends EntityReferenceViewModeWidget {

  use CardWidgetTrait;

  /**
   * {@inheritdoc}
   */
  public function formElement(
    FieldItemListInterface $items,
    $delta,
    array $element,
    array &$form,
    FormStateInterface $form_state
  ) {


    // Call the parent classes formElement function.
    $element = parent::formElement($items, $delta, $element, $form, $form_state);

      // Remove the suffix from the view mode.
    $element['view_mode']['#suffix'] = '';

    $element = $this->cardOptions($items, $delta, $element, $form, $form_state);

    return $element;
  }

}
